
#include <cpctelera.h>
#include "entities.h"
#include "../game.h"
#include "../sprites/prota.h"
#include "../sprites/ammo.h"
#include "../sprites/disparo.h"
#include "../maps/mapa1.h"
#include "../maps/mapa2.h"
#include "../maps/mapa3.h"
#include "../maps/mapa4.h"
#include "../maps/mapa5.h"
#include "../maps/mapa6.h"

u8 const CoorPuntosControlXVIDA[NUM_PUNTOS_CONTROL] = {
	PUNTO_CONTROL_A_X, PUNTO_CONTROL_B_X, PUNTO_CONTROL_C_X,PUNTO_CONTROL_D_X, PUNTO_CONTROL_VIDA_X,
};

u8 const CoorPuntosControlYVIDA[NUM_PUNTOS_CONTROL] = {
	PUNTO_CONTROL_A_Y, PUNTO_CONTROL_B_Y, PUNTO_CONTROL_C_Y,PUNTO_CONTROL_D_Y, PUNTO_CONTROL_VIDA_Y,
};

u8 const CoorPuntosControlXAMMO[NUM_PUNTOS_CONTROL] = {
	PUNTO_CONTROL_A_X, PUNTO_CONTROL_B_X, PUNTO_CONTROL_C_X,PUNTO_CONTROL_D_X, PUNTO_CONTROL_AMMO_X,
};

u8 const CoorPuntosControlYAMMO[NUM_PUNTOS_CONTROL] = {
	PUNTO_CONTROL_A_Y, PUNTO_CONTROL_B_Y, PUNTO_CONTROL_C_Y,PUNTO_CONTROL_D_Y, PUNTO_CONTROL_AMMO_Y,
};


u8 CoorPuntosControlX[NUM_PUNTOS_CONTROL];
u8 CoorPuntosControlY[NUM_PUNTOS_CONTROL];

u8 disparo=10;
u8 balaEsquivada=NO;
u8 direccionEsquivar=NO;
u8 direccionBalaAux=NO;

u8* obtenerTilePtr(u8 x, u8 y,u8 nmapa) {
	u8* mapa;

	if(nmapa==0){
		mapa = g_mapa1;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa1_W + x/2;
	}

	if(nmapa==1){
		mapa = g_mapa2;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa2_W + x/2;
	}
	if(nmapa==2){
		mapa = g_mapa3;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa3_W + x/2;
	}
	if(nmapa==3){
		mapa = g_mapa4;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa4_W + x/2;
	}
	if(nmapa==4){
		mapa = g_mapa5;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa4_W + x/2;
	}
	if(nmapa==5){
		mapa = g_mapa6;
		return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa4_W + x/2;
	}

	//mapa = g_mapa1;
	return 0;

}

u8 colisionAbajoDerechaBala(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->bala.x+ANCHO_BALA, prota->bala.y + ALTO_BALA,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionAbajoIzquierdaBala(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->bala.x, prota->bala.y + ALTO_BALA,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionArribaDerechaBala(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->bala.x+ANCHO_BALA, prota->bala.y,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionArribaIzquierdaBala(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->bala.x, prota->bala.y,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}
void colisionBalaMapa(TEntity* prota){
	if(colisionAbajoDerechaBala(prota)||
		colisionAbajoIzquierdaBala(prota)||
		colisionArribaDerechaBala(prota)||
		colisionArribaIzquierdaBala(prota)){
		prota->bala.colisionado=SI;
		prota->bala.disparado=NO;
}

}

u8 colisionAbajoDerecha(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->x+ANCHO_PROTA, prota->y + ALTO_PROTA,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionAbajoIzquierda(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->x, prota->y + ALTO_PROTA,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionArribaDerecha(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->x+ANCHO_PROTA, prota->y,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}

u8 colisionArribaIzquierda(TEntity* prota) {
	u8* tileSuelo = obtenerTilePtr(prota->x, prota->y,prota->nmapa);
	if (*tileSuelo <= 23 && *tileSuelo>=19 )
		return 1;

	return 0;
}


void moverDerecha(TEntity* prota){


	if(prota->dir!=derecha){
		prota->dir=derecha;
	}



	if(prota->x < LIMITE_DERECHO){
		prota->x++;
		if(colisionAbajoDerecha(prota) || colisionArribaDerecha(prota)){
			prota->x--;
		}
		else{
			prota->state=moviendo;
			if(prota->x>69)
				avanzarMapa();
		}
	}

}


void moverIzquierda(TEntity* prota){



	if(prota->dir!=izquierda){
		prota->dir=izquierda;
	}



	if(prota->x >0){
		prota->x--;
		if(colisionArribaIzquierda(prota) || colisionAbajoIzquierda(prota)){
			prota->x++;
		}
		else{
			prota->state=moviendo;
			if(prota->x<1)
				retrocederMapa();
		}
	}
}

void moveUp(TEntity* prota){

	if(prota->dir!=arriba){
		prota->dir=arriba;
	}
	if(prota->y>0){
		prota->y--;
		prota->y--;
		if(colisionArribaDerecha(prota) || colisionArribaIzquierda(prota)){
			prota->y++;
			prota->y++;

		}
		else{
			prota->state=moviendo;
			if(prota->y<33)
				subirMapa();
		}
	}	
}

void moveDown(TEntity* prota){

	if(prota->dir!=abajo){
		prota->dir=abajo;
	}

	if(prota->y<ALTO_PANTALLA-G_PROTA_00_H){
		prota->y++;
		prota->y++;
		if(colisionAbajoDerecha(prota) || colisionAbajoIzquierda(prota)){
			prota->y--;
			prota->y--;			
		}
		else{
			prota->state=moviendo;
			if(prota->y>175)
				bajarMapa();

		}
	}	
}



u8 disparar(TEntity* prota){

	if(prota->municion>0 && prota->bala.disparado==NO){

		if(prota->dir==derecha){
			prota->bala.dir=derecha;

			prota->bala.x=prota->x+G_PROTA_00_W+1;//uno mas para que no borre al prota
			prota->bala.y=prota->y+(G_PROTA_00_H/2);
			//cpct_drawSprite(g_disparo, cpctm_screenPtr(CPCT_VMEM_START, pprota->bala.x,rota->bala.y),2, 2);

		}
		else if(prota->dir==izquierda){
			prota->bala.dir=izquierda;

			//cpct_drawSprite(g_disparo, cpctm_screenPtr(CPCT_VMEM_START, prota->x-2,prota->y+(G_PROTA_00_H/2)),2, 2);
			prota->bala.x=prota->x-3;//menos ancho de la bala menos uno para que no borre al prota
			prota->bala.y=prota->y+(G_PROTA_00_H/2);
		}

		else if(prota->dir==arriba){
			prota->bala.dir=arriba;
			//cpct_drawSprite(g_disparo, cpctm_screenPtr(CPCT_VMEM_START, prota->x+(G_PROTA_00_W/2),prota->y-G_PROTA_00_H/2),2, 2);
			prota->bala.x=prota->x+(G_PROTA_00_W/2);
			prota->bala.y=prota->y-G_PROTA_00_H-4;
		}

		else if(prota->dir==abajo){
			prota->bala.dir=abajo;

			//cpct_drawSprite(g_disparo, cpctm_screenPtr(CPCT_VMEM_START, prota->x+(G_PROTA_00_W/2),prota->y+G_PROTA_00_H),2, 2);
			prota->bala.x=prota->x+(G_PROTA_00_W/2);
			prota->bala.y=prota->y+G_PROTA_00_H+4;

		}


		cpct_drawSprite(g_disparo, cpctm_screenPtr(CPCT_VMEM_START, prota->bala.x,prota->bala.y),2, 2);
		prota->bala.disparado=SI;
		prota->bala.nmapa=prota->nmapa;
		prota->municion--;

		return 1;
	}
	return 0;
}

void trayectoBala(TEntity* entity){
	if(entity->bala.x<ANCHO_PANTALLA-4 && entity->bala.y<ALTO_PANTALLA-20 && entity->bala.x>4 && entity->bala.y>39){
		if(entity->bala.dir==derecha)
			entity->bala.x+=2;
		else if(entity->bala.dir==izquierda){
			entity->bala.x-=2;
		}else if(entity->bala.dir==arriba){
			entity->bala.y-=4;
			
		}else if(entity->bala.dir==abajo){
			entity->bala.y+=4;
		}

	}else{

		entity->bala.disparado=NO;
		entity->bala.colisionado=SI;

	}
}

//COLISIONES
/*
u8 comprobarColision(TEntity* entity1, TEntity* entity2){

	if(entity1->nmapa==entity2->nmapa){
		if (entity1->x < entity2->x + G_PROTA_00_W &&
			entity1->x + G_PROTA_00_W > entity2->x &&
			entity1->y < entity2->y + G_PROTA_00_H &&
			G_PROTA_00_W + entity1->y > entity2->y) {
			return 1;
	}else{
		return 0;
	}
	
}
else{
	return 0;
}

}
*/

u8 colisionAmmo(TEntity* entity1, TAmmo* entity2){

	if (entity1->x < entity2->x + G_AMMO_W &&
		entity1->x + G_PROTA_00_W > entity2->x &&
		entity1->y < entity2->y + G_AMMO_H &&
		G_PROTA_00_W+4 + entity1->y > entity2->y) {
		return 1;
}else{
	return 0;
}

}

u8 colisionVida(TEntity* entity1, TVida* entity2){

	if(entity1->vida<5){
	if (entity1->x < entity2->x + G_AMMO_W &&
		entity1->x + G_PROTA_00_W > entity2->x &&
		entity1->y < entity2->y + G_AMMO_H &&
		G_PROTA_00_W+4 + entity1->y > entity2->y) {
		return 1;
}else{
	return 0;
}
}else{
	return 0;
}

}

u8 colisionBala(TEntity* entity1, TBala* entity2){

	if(entity2->disparado==SI){


		if (entity1->x < entity2->x + G_DISPARO_W &&
			entity1->x + G_PROTA_00_W > entity2->x &&
			entity1->y < entity2->y + G_DISPARO_H &&
			G_PROTA_00_W +4+ entity1->y > entity2->y) {
			return 1;

	}else{
		return 0;
	}
}
else{
	return 0;
}
}




//IA




u8 moverDerechaEnemigo(TEntity* prota){


	if(prota->dir!=derecha){
		prota->dir=derecha;
	}



	if(prota->x < LIMITE_DERECHO){
		prota->x++;
		if(colisionAbajoDerecha(prota) || colisionArribaDerecha(prota)){
			prota->x--;
			return 1;
		}
	}
	return 0;
}



u8 moverIzquierdaEnemigo(TEntity* prota){



	if(prota->dir!=izquierda){
		prota->dir=izquierda;
	}



	if(prota->x >0){
		prota->x--;
		if(colisionArribaIzquierda(prota) || colisionAbajoIzquierda(prota)){
			prota->x++;
			return 1;
		}

	}

	return 0;

}

u8 moveUpEnemigo(TEntity* prota){

	if(prota->dir!=arriba){
		prota->dir=arriba;
	}
	if(prota->y>0){
		prota->y--;
		prota->y--;
		if(colisionArribaDerecha(prota) || colisionArribaIzquierda(prota)){
			prota->y++;
			prota->y++;
			return 1;
		}

	}	
	return 0;
}

u8 moveDownEnemigo(TEntity* prota ){

	if(prota->dir!=abajo){
		prota->dir=abajo;
	}

	if(prota->y<ALTO_PANTALLA-G_PROTA_00_H){
		prota->y++;
		prota->y++;
		if(colisionAbajoDerecha(prota) || colisionAbajoIzquierda(prota)){
			prota->y--;
			prota->y--;			
			return 1;
		}

	}	
	return 0;
}




void moverPuntoControl(TEntity* enemigo, TEntity* prota, u8 IDDEstino){

	u8 ColDerecha=NO;
	u8 ColIzquierda=NO;



	if(enemigo->PuntoDecidido==NO){

		if(IDDEstino!=IDPROTA){
			decidirPuntoControl(enemigo, prota, IDDEstino);
		}
		else{
			decidirPuntoControlPerseguir(enemigo, prota);
		}
	}


	if(enemigo->x-CoorPuntosControlX[enemigo->IDDecidido]<0){
		ColDerecha=moverDerechaEnemigo(enemigo);  

	}else if(enemigo->x-CoorPuntosControlX[enemigo->IDDecidido]>0){
		ColIzquierda=moverIzquierdaEnemigo(enemigo);
	}

	else{
		if(enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]<-1){
			moveDownEnemigo(enemigo);
		}else if(enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]>0){
			moveUpEnemigo(enemigo);

		}
	}


	if(ColDerecha || ColIzquierda){

		if(enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]<-1){
			moveDownEnemigo(enemigo);
		}else if(enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]>0){
			moveUpEnemigo(enemigo);

		}
	}

	if(enemigo->x-CoorPuntosControlX[enemigo->IDDecidido]==0 && (enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]==-1 || enemigo->y-CoorPuntosControlY[enemigo->IDDecidido]==0)){
		enemigo->IDPuntoControl=enemigo->IDDecidido;
		enemigo->PuntoDecidido=NO;
	}


}

void decidirPuntoControlPerseguir(TEntity* enemigo, TEntity* prota){

	u8 i;
	i16 distancia;
	i16 menordistancia;
	i16 x, y;
	u8 ID=10;


	for(i=0; i<4; i++){
		CoorPuntosControlX[i]=CoorPuntosControlXAMMO[i];
		CoorPuntosControlY[i]=CoorPuntosControlYAMMO[i];
	}


	menordistancia=10000;
	for(i=0; i<4; i++){


    x=prota->x-CoorPuntosControlX[i];//Calculamos las distancias del enemigo con los puntos de control
    y=prota->y-CoorPuntosControlY[i];

    distancia=2*abs(x)+abs(y);

    if(distancia<menordistancia){//Buscamos el punto de control mas pequeño

    	menordistancia=distancia;

    	ID=i;

    }


}

enemigo->IDDecidido=ID;
    enemigo->PuntoDecidido=SI;//El punto ha sido decidido, asi que seteamos el valor para que la funcion no sea llamada constantemente

    

}

void decidirPuntoControl(TEntity* enemigo, TEntity* prota, u8 IDDEstino){

	u8 i;
	u8 ID;
	u8 IDlejos=100;
	i16 distancia=0;
	i16 menordistancia;
	i16 x, y;
	i16 distanciaProtaID;
	i16 distanciaProtaIDlejos;

	if(IDDEstino==IDAMMO){

		for(i=0; i<NUM_PUNTOS_CONTROL; i++){
			CoorPuntosControlX[i]=CoorPuntosControlXAMMO[i];
			CoorPuntosControlY[i]=CoorPuntosControlYAMMO[i];
		}


	}else{

		for(i=0; i<NUM_PUNTOS_CONTROL; i++){
			CoorPuntosControlX[i]=CoorPuntosControlXVIDA[i];
			CoorPuntosControlY[i]=CoorPuntosControlYVIDA[i];
		}

	}

	menordistancia=600;
	ID=100;

	for(i=0; i<NUM_PUNTOS_CONTROL; i++){

  if(enemigo->IDPuntoControl!=i){//No comprobamos el punto de control sobre el que esta o ha estado el prota


   if(i!=4){//El i=4 es el paquete de vida, es especial asi que lo tratamos de manera diferente

    x=enemigo->x-CoorPuntosControlX[i];//Calculamos las distancias del enemigo con los puntos de control
    y=enemigo->y-CoorPuntosControlY[i];

    distancia=2*abs(x)+abs(y);

    if(distancia<menordistancia){//Buscamos el punto de control mas pequeño

    	menordistancia=distancia;
     if(ID!=100){//En caso de que el ID ya haya sido seteado antes, el anterior lo dejamos como el ID segundo mas lejano
     	IDlejos=ID;
     }

     ID=i;//Seteamos el id
 }
}    
   else if(i==4 && (enemigo->IDPuntoControl==2 || enemigo->IDPuntoControl==3 || enemigo->IDPuntoControl==10)){//En el caso de que estemos con el punto de control de la vida comprobamos que estemos en los puntos de control anexos a el

    x=enemigo->x-CoorPuntosControlX[i];//Hacemos lo mismo que el paso anterior
    y=enemigo->y-CoorPuntosControlY[i];

    if(IDDEstino==IDVIDA){

    	if(enemigo->IDPuntoControl==2){
    		distancia=abs(y);

    	}
    	else{
    		distancia=2*abs(x)+abs(y);
    	}	
    }

    if(IDDEstino==IDAMMO){

    	distancia=abs(y);

    }


    if(distancia<menordistancia){

    	menordistancia=distancia;
    	if(ID!=100){
    		IDlejos=ID;
    	}
    	ID=i;
    }
}

}


}

menordistancia=600;

 if(ID==0){// Hay un caso especial, cuando el punto de control mas cercano es el 0 solo seteamos un ID, puesto que no vuelve a entrar en el if que setea los ID, por lo que IDlejos no tiene valor, de este modo buscamos el segundo ID mas cercano
  for(i=1; i<NUM_PUNTOS_CONTROL; i++){//La logica es la misma pero solo seteamos un ID
  	if(enemigo->IDPuntoControl!=i){

  		if(i!=4){

  			x=enemigo->x-CoorPuntosControlX[i];
  			y=enemigo->y-CoorPuntosControlY[i];

  			distancia=2*abs(x)+abs(y);


  			if(distancia<menordistancia){
  				menordistancia=distancia;
  				IDlejos=i;
  			}

  		}
  		else if(i==4 && (enemigo->IDPuntoControl==2 || enemigo->IDPuntoControl==3 || enemigo->IDPuntoControl==10)){


  			x=enemigo->x-CoorPuntosControlX[i];
  			y=enemigo->y-CoorPuntosControlY[i];

  			if(IDDEstino==IDVIDA){

  				if(enemigo->IDPuntoControl==2){
  					distancia=abs(y);

  				}
  				else{
  					distancia=2*abs(x)+abs(y);
  				}	
  			}

  			if(IDDEstino==IDAMMO){

  				distancia=abs(y);

  			}

  			if(distancia<menordistancia){
  				menordistancia=distancia;
  				IDlejos=i;
  			}
  		}
  		
  	}
  }
}
/*
 if(IDlejos==4 && prota->IDPuntoControl==2){
  intercambiarID=IDlejos;
  IDlejos=ID;
  ID=intercambiarID;
  cpct_drawStringM0("ESTADO POCA VIDA ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
 }*/

 x=prota->x-CoorPuntosControlX[ID];//Calculamos las distancias del prota a los puntos de control que hemos resaltaado
 y=prota->y-CoorPuntosControlY[ID];

 distanciaProtaID=2*abs(x)+abs(y);

 x=prota->x-CoorPuntosControlX[IDlejos];
 y=prota->y-CoorPuntosControlY[IDlejos];

 distanciaProtaIDlejos=2*abs(x)+abs(y);



 enemigo->PuntoDecidido=SI;//El punto ha sido decidido, asi que seteamos el valor para que la funcion no sea llamada constantemente

 if(distanciaProtaID<distanciaProtaIDlejos){//Miramos en que punto esta el prota mas cerca, y nos vamos al contrario
  if(distanciaProtaID>50){//Pero solo en caso de que el prota este a una distancia peligrosa
  	enemigo->IDDecidido=ID;
  }
  else{
  	enemigo->IDDecidido=IDlejos;
  }
}else{
	enemigo->IDDecidido=ID;
}
}


i16 abs(i16 num){

	i16 numPositivo=0;
	if(num<0){
		numPositivo=-num;
	}else{
		numPositivo=num;
	}

	return numPositivo;
}

/*
i16 sqrt(i16 n){
	i16 x=n;
	u8 y=1;
	u8 e=0.000001;
	while(x-y>e){
		x=(x+y)/2;
		y=n/x;
	}
	return x;
}

u8 pow(u8 x, u8 n) {   
	u8 ret;
	u8 i;

	ret=x;

	if ( n )
		for ( i=0; i <n-1; i++)
			ret = x*ret;
		else 
			ret = 1;
		return ret;
	}
*/
void tomarDecision(TEntity* enemigo, TEntity* prota){
	i16 xE, yE, xB,yB;
	u8 esquivo=10;
	disparo=10;
	xE = enemigo->x - prota->x;
	yE = enemigo->y - prota->y;
	xE=abs(xE);
	yE=abs(yE);
 //Nota: ahora priorizamos disparar porque si estas huyendo a por una vida pero te disparan por el camino en el que estan antes de seguir a por la vida
 //es mejor esquivar la bala, para ver si estra en estado de esquivar o no llamamos a la funcion de "decisionEsquivar" pero solo la llamamos cuando la bala
 //este cerca del enemigo para ahorrar calculos cuando el prota no ha disparado o a disparado hacia otro lado.

if(enemigo->nmapa==prota->nmapa){



	if(enemigo->state!=disparando && enemigo->state!=esquivar){
  //ESTADOS BASICOS

		if(enemigo->vida>1){
    //tiene suficiente vida
			if(enemigo->municion>4){
     //tiene suficiente municion
				if(prota->nmapa==enemigo->nmapa){
      //esta cerca del prota
					enemigo->state=perseguir;
				}else{
      //tiene vida y municion pero no esta el prota cerca
					enemigo->state=moviendo;
				}

			}else{
     //le falta municion
				enemigo->state=pocaMunicion;
			}
		}else{
    //le falta vida
			enemigo->state=pocaVida;
		}

   ////

   //ESTADOS INMEDIATOS, una vez hechos se vuelve al estado anterior, es decir una vez de esquivar volveria a su estado anterior, si era buscar una
   // vida por ejemplo esquivaria y luego volveria al estado de buscar la vida

		if(prota->bala.disparado==SI && balaEsquivada==NO){
  //si estas cerca del prota y este dispara intentas esquivar
			xB = enemigo->x - prota->bala.x;
			yB = enemigo->y - prota->bala.y;
			xB=abs(xB);
			yB=abs(yB);
   //distancia2=sqrt(x*x+y*y);
			if(yB<RANGOESQUIVARY && xB<RANGOESQUIVARX){

				esquivo=decisionEsquivar2(enemigo,prota,xE,yE);
				esquivo+=3;
			}

		}

		if(prota->bala.colisionado==SI){
			borrarBala();
			prota->bala.colisionado=NO;

			if(balaEsquivada==SI){
				balaEsquivada=NO;
			}

		}

		if((xE<RANGODISPARARX+enemigo->masRango) && (yE<RANGODISPARARY+enemigo->masRango+enemigo->masRango) && enemigo->state!=pocaMunicion){
   //esto esta aqui tambien porque sino solo miraria si puede disparar cuando el prota dispara (que es como lo teniamos antes)

			esquivo=decisionEsquivar2(enemigo,prota,xE,yE);
			if((yB>RANGOESQUIVARY+enemigo->masRango+enemigo->masRango) || (xB>RANGOESQUIVARX+enemigo->masRango) || prota->bala.disparado==NO){
				esquivo=esquivo-6;
			}


		}


		if(disparo>=15 && disparo>esquivo){
			enemigo->estadoAnterior=enemigo->state;
			enemigo->state=posicionDisparar;
  //cpct_drawStringM0("Disparo > esquivo", cpct_getScreenPtr(CPCT_VMEM_START, 10, 20),  2, 5);
		}else if(esquivo>=15 && esquivo>=disparo){
 //  cpct_drawStringM0("Esquivo > disparo", cpct_getScreenPtr(CPCT_VMEM_START, 10, 20),  2, 5);
			enemigo->estadoAnterior=enemigo->state;
			enemigo->state=esquivar;
		}

	}else if(enemigo->state!=esquivar){
			if(enemigo->vida==1){
		enemigo->state=pocaVida;
	}
	}




}
else{
	enemigo->state=moviendo;
}

}


u8 decisionEsquivar2(TEntity* enemigo, TEntity* prota,i16 xE, i16 yE){
	u8 esquivo=10;
	disparo=10;

  //DIRECCION
	if(enLaEspalda(enemigo,prota)){
   //si esta en la espalda resto 2, para que sea MAS DIFICIL ESQUIVAR
		disparo-=2;
		esquivo-=2;


	}else{
   //si no esta por la espalda lo puede ver venir , MAS FACIL ESQUIVAR
		esquivo++;
		disparo++;
	}

	if((xE<RANGODISPARARX+enemigo->masRango) && (yE<RANGODISPARARY+enemigo->masRango+enemigo->masRango)){
  //esta bastante cerca como para disparar
		disparo+=5;
	}else{
		disparo-=3;
	}


  //VIDA PROTA
  //si el jugador tiene mucha vida mas dificil es para el jugador, mucha vida del prota ->MAS FACIL ESQUIVAR
  // si el jugador tiene poca vida los enemigos esquivan menos porque PREFIERE DISPARAR aunque mueran para intentar matarlo,
  // poca vida del prota -> MAS DICIL ESQUIVAR
	if(prota->vida>=5){
		esquivo+=3;
	}else if(prota->vida==4){
		esquivo+=2;
	}else if(prota->vida==3){
		esquivo++;
	}else if (prota->vida==2){
		esquivo--;
		disparo++;
	}else if (prota->vida==1){
		esquivo-=2;
		disparo+=2;
	}

  //MUNICION
	if(enemigo->municion<3){
   //si quedan muy pocas balas prefiere antes esquivar que disparar
		disparo-=3;
	}
	return esquivo;
}

u8 enLaEspalda(TEntity* enemigo, TEntity* prota){
	u8 espalda=NO;

	if(enemigo->dir==prota->dir){
   //miran hacia el mismo sitio
		if(enemigo->dir==derecha && enemigo->x>prota->x){
			espalda=SI;
		}else if(enemigo->dir==izquierda && enemigo->x<prota->x){
			espalda=SI;
		}else if(enemigo->dir==arriba && enemigo->y<prota->y){
			espalda=SI;
		}else if(enemigo->dir==abajo && enemigo->y>prota->y){
			espalda=SI;
		}
	}
	return espalda;
}



u8 direccionEnemigo(TEntity* enemigo, TEntity* prota){
 //este metodo te dice la direccion en la que se encuentra el prota para poder disparar hacia esa posicion e intentar matarlo
 //izquierda=1, derecha=2, arriba=3, abajo=4
	u8 direccion=0;
	i16 horizontal=0;
	i16 vertical=0;

	horizontal=enemigo->x-prota->x;
	vertical=enemigo->y-prota->y;
	horizontal=abs(horizontal);
	vertical=abs(vertical);
//como no puedes mirar en diagonal compruebas hacia que lado te interesa mirar mas, es decir si el enemigo esta arriba derecha
//entonces miras si esta mas cerca horizontalmente que verticalmente te interesa mas mirar hacia el lado que esta mas lejos para moverte en la direccion
//que menos lejos esta
	if(horizontal+horizontal>=vertical){
 //hay mas distancia en la X que en la Y, te interesa mirar en horizontal

		if(enemigo->x>prota->x){
   //prota esta en la izquierda
			direccion=izquierda;
		}else{
   //prota en la derecha
			direccion=derecha;
		}
	}else{
		if(enemigo->y>prota->y){
  //prota arriba
			direccion=arriba;
		}else{
   //prota abajo
			direccion=abajo;
		}
	}



	
	return direccion;
}



void esquivarEnemigo(TEntity* enemigo, TEntity* prota){


	u8 direccion;

	direccion=prota->bala.dir;

	if(direccionBalaAux==NO){
		direccionBalaAux=direccion;
	}

	if(direccion==derecha || direccion==izquierda){

		if(prota->bala.x>=enemigo->x && prota->bala.x<=enemigo->x+G_PROTA_00_W){
			balaEsquivada=SI;
		}
	}

	if(direccion==arriba || direccion==abajo){

		if(prota->bala.y>=enemigo->y && prota->bala.y<=enemigo->y+G_PROTA_00_H){
			balaEsquivada=SI;
		}
	}

	if(balaEsquivada==NO && direccionEsquivar==NO){


		if(direccion==izquierda || direccion==derecha){


			enemigo->y-=G_PROTA_00_H;
			if(!colisionArribaIzquierda(enemigo) && !colisionArribaDerecha(enemigo)){
				enemigo->y+=G_PROTA_00_H;
				direccionEsquivar=arriba;		
			}
			else{
				enemigo->y+=G_PROTA_00_H;
				direccionEsquivar=abajo;		
			}


		}
		else{

			enemigo->x-=G_PROTA_00_W;
			if(!colisionArribaIzquierda(enemigo) && !colisionAbajoIzquierda(enemigo)){
				enemigo->x+=G_PROTA_00_W;
				direccionEsquivar=izquierda;		
			}
			else{
				enemigo->x+=G_PROTA_00_W;
				direccionEsquivar=derecha;		
			}
		}
	}

	if(balaEsquivada==NO){

		switch(direccionEsquivar){

			case arriba:
			moveUpEnemigo(enemigo);
			break;

			case abajo:
			moveDownEnemigo(enemigo);
			break;

			case izquierda:
			moverIzquierdaEnemigo(enemigo);
			break;

			case derecha:
			moverDerechaEnemigo(enemigo);
			break;

		}

	}
	else{
		direccionEsquivar=NO;
		direccionBalaAux=NO;
		enemigo->state=enemigo->estadoAnterior;
	}


}

void moviendoMapa(TEntity* enemigo){

	if(++enemigo->WaitCambioMapa==WAIT_CAMBIO){

		switch(enemigo->nmapa){

			case 0:
			enemigo->nmapa=1;
			enemigo->x=5;
			enemigo->y=100;
			break;

			case 1:
			enemigo->nmapa=2;
			enemigo->x=5;
			enemigo->y=100;
			break;

			case 2:
			enemigo->nmapa=5;
			enemigo->x=39;
			enemigo->y=35;
			break;

			case 5:
			enemigo->nmapa=4;
			enemigo->x=70;
			enemigo->y=100;
			break;

			case 4:
			enemigo->nmapa=3;
			enemigo->x=70;
			enemigo->y=100;
			break;

			case 3:
			enemigo->nmapa=0;
			enemigo->x=41;
			enemigo->y=170;
			break;

		}

		enemigo->WaitCambioMapa=0;

	}

}


/*/////////////////////////////////////////////////////////////////////////////////////////DECISION ESQUIVAR ANTIGUO
u8 decisionEsquivar(TEntity* enemigo, TEntity* prota,i16 xE, i16 yE){
  //si esquivo>=5 entonces esquiva
  //NOTA: LLEVAR CUIDADO PORQUE U8 NO ADMITE NEGATIVOS Y SI EL PRIMER METODO SE LE RESTA 2 VA A PETAR
	u8 esquivo=13;
	disparo=10;

  //DIRECCION
	if(enLaEspalda(enemigo,prota)){
   //si esta en la espalda resto 2, para que sea MAS DIFICIL ESQUIVAR
		disparo--;
		disparo--;
		esquivo=esquivo-2;
 // cpct_drawStringM0("1DIS -2", cpct_getScreenPtr(CPCT_VMEM_START, 0, 40),  2, 5);

		
	}else{
   //si no esta por la espalda lo puede ver venir , MAS FACIL ESQUIVAR
		esquivo++;
		disparo++;
 // cpct_drawStringM0("2DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 40),  2, 5);
	}

	if(xE<RANGODISPARARX && yE<RANGODISPARARY){
  //esta bastante cerca como para disparar
		disparo++;
 //cpct_drawStringM0("3DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 50),  2, 5);
	}else{
		disparo=disparo-3;
 // cpct_drawStringM0("4DIS -3", cpct_getScreenPtr(CPCT_VMEM_START, 0, 50),  2, 5);
	}
  //DISTANCIA
	if(xE<RANGODISPARARX-20 && yE<RANGODISPARARY-40){
   //si estas cerca tienes menos tiempo para reaccionas, MAS DIFICIL ESQUIVAR
		esquivo--;
		disparo++;
		disparo++;
  //cpct_drawStringM0("5DIS +2", cpct_getScreenPtr(CPCT_VMEM_START, 40, 60),  2, 5);
	}else{
   //si estas lejos lo puedes ver con mas tiempo por lo que es MAS FACIL ESQUIVAR
		esquivo++;
	}

  //VIDA PROTA
  //si el jugador tiene mucha vida mas dificil es para el jugador, mucha vida del prota ->MAS FACIL ESQUIVAR
  // si el jugador tiene poca vida los enemigos esquivan menos porque PREFIERE DISPARAR aunque mueran para intentar matarlo,
  // poca vida del prota -> MAS DICIL ESQUIVAR
	if(prota->vida>=5){
		esquivo=esquivo+3;
	}else if(prota->vida==4){
		esquivo=esquivo+2;
	}else if(prota->vida==3){
		esquivo++;
	}else if (prota->vida==2){
  //hay que poner algo aqui de que el estado pasaria a disparar si puede
		esquivo--;
		disparo++;
 // cpct_drawStringM0("6DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 70),  2, 5);
	}else if (prota->vida==1){
		esquivo=esquivo-2;
		disparo++;
		
		disparo++;
 //cpct_drawStringM0("7DIS +2", cpct_getScreenPtr(CPCT_VMEM_START, 40, 70),  2, 5);
	}

  //VIDA ENEMIGO
	if(enemigo->vida>=5){
		esquivo=esquivo-2;
		disparo++;
 // cpct_drawStringM0("8DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 80),  2, 5);
	}else if(enemigo->vida==4){
		esquivo--;
		disparo++;
 // cpct_drawStringM0("9DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 80),  2, 5);
	}else if(enemigo->vida==2){
		esquivo++;
		disparo--;
  //cpct_drawStringM0("10DIS -1", cpct_getScreenPtr(CPCT_VMEM_START, 0, 80),  2, 5);
	}else if(enemigo->vida==1){
		esquivo=esquivo+2;
		disparo--;
		disparo--;
  //cpct_drawStringM0("11DIS -2", cpct_getScreenPtr(CPCT_VMEM_START, 0, 80),  2, 5);
	}

  //MUNICION
	if(enemigo->municion>=15){
   //tiene mucha municion prefiere disparar a esquivar MAS DICIFIL ESQUIVAR
		esquivo=esquivo-2;
		disparo++;
		disparo++;
  //cpct_drawStringM0("12DIS +2", cpct_getScreenPtr(CPCT_VMEM_START, 40, 90),  2, 5);
	}else if(enemigo->municion>=10){
		disparo++;
		esquivo--;
 // cpct_drawStringM0("13DIS +1", cpct_getScreenPtr(CPCT_VMEM_START, 40, 90),  2, 5);
	}else if(enemigo->municion>5 && enemigo->municion<=10){
		esquivo++;
	}else if(enemigo->municion<5){
   //si quedan muy pocas balas prefiere antes esquivar que disparar
		disparo--;
 // cpct_drawStringM0("14DIS -1", cpct_getScreenPtr(CPCT_VMEM_START, 0, 90),  2, 5);
		esquivo=esquivo+2;
	}

  //NOTA: donde pone que prefiere disparar se podria llamar a un metodo para que calcule en que circustancias disparar
  //ese metodo que devuelva un valor que sera las probabilidades que hay de disparar, si disparar>esquivar dispara y si
  //esquivar > disparar entonces esquiva, como este metodo devuelve un entero si el entero es int>5&&<50 esquiva, si int>50dispara si int<5 ni esquiva ni dispara




	return esquivo;
}

*//////////////////////////////////////////////////////////////////////////////////////////DECISION ESQUIVAR ANTIGUO


void moverParaDisparar(TEntity* enemigo,TEntity* prota, u8 dir){

	if(dir==derecha){
		if(enemigo->y<prota->y){
			moveDownEnemigo(enemigo);
			if(enemigo->y>=(prota->y+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}else{
			moveUpEnemigo(enemigo);
			if(enemigo->y<=(prota->y+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}
	}else if(dir==izquierda){
		if(enemigo->y<prota->y){
			moveDownEnemigo(enemigo);
			if(enemigo->y>=(prota->y+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}else{
			moveUpEnemigo(enemigo);
			if(enemigo->y<=(prota->y+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}
	}else if(dir==arriba){
		if(enemigo->x<prota->x){
			moverDerechaEnemigo(enemigo);
			if(enemigo->x>=(prota->x+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}else{
			moverIzquierdaEnemigo(enemigo);
			if(enemigo->x<=(prota->x+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}
	}else if(dir==abajo){
		if(enemigo->x<prota->x){
			moverDerechaEnemigo(enemigo);
			if(enemigo->x>=(prota->x+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}else{
			moverIzquierdaEnemigo(enemigo);
			if(enemigo->x<=(prota->x+G_PROTA_00_H/2)){
				enemigo->state=disparando;
			}
		}
	}

	if(enemigo->bala.disparado==SI){
		enemigo->dir=enemigo->bala.dir;
	}

}

void realizarAccion(TEntity* enemigo, TEntity* prota){
	u8 direc=0;
	switch(enemigo->state){
		case pocaVida:
  //logica buscar vida
		moverPuntoControl(enemigo, prota, IDVIDA);

 //cpct_drawStringM0("ESTADO POCA VIDA ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case pocaMunicion:
		moverPuntoControl(enemigo, prota, IDAMMO);
  //logica buscar municion
 //cpct_drawStringM0("ESTADO POCA MUNICION", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case moviendo:
  //logica moverse por el mapa
		moviendoMapa(enemigo);
 //cpct_drawStringM0("ESTADO MOVIENDO ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case esquivar:
  //logica esquivar bala (sera una direccion random, si la esquivas bien y sino mala suerte)
		esquivarEnemigo(enemigo,prota);
 //cpct_drawStringM0("ESTADO ESQUIVAR ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case posicionDisparar:
  //logica disparar 
		direc=direccionEnemigo(enemigo,prota);
		moverParaDisparar(enemigo,prota,direc);
 //cpct_drawStringM0("ESTADO DISPARANDO ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case perseguir:
  //logica perseguir prota

		moverPuntoControl(enemigo, prota, IDPROTA);
 //cpct_drawStringM0("ESTADO perseguir ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);
		break;

		case disparando:

		direc=direccionEnemigo(enemigo,prota);
		enemigo->dir=direc;
		disparar(enemigo);
		enemigo->state=enemigo->estadoAnterior;
  //logica estar parado no se que logica tiene esto pero bueno 
		break;

	}

}
