#ifndef _ENTITIES_H_
#define _ENTITIES_H_

#include <types.h>
#include <stdio.h>

#include "../game.h"

#define SI 1
#define NO 0
#define RANGOPERSEGUIR 100
#define RANGODISPARARX 25
#define RANGODISPARARY 50
#define RANGOESQUIVARX 20
#define RANGOESQUIVARY 40

#define IDAMMO 10
#define IDVIDA 20
#define IDPROTA 30

#define IZQUIERDA 6
#define DERECHA 7
#define ARRIBA 8
#define ABAJO 9

#define PUNTO_CONTROL_A_X 10
#define PUNTO_CONTROL_A_Y 80

#define PUNTO_CONTROL_B_X 60
#define PUNTO_CONTROL_B_Y 80

#define PUNTO_CONTROL_C_X 10
#define PUNTO_CONTROL_C_Y 150

#define PUNTO_CONTROL_D_X 60
#define PUNTO_CONTROL_D_Y 150

#define PUNTO_CONTROL_VIDA_X 50
#define PUNTO_CONTROL_VIDA_Y 140

#define PUNTO_CONTROL_AMMO_X 30
#define PUNTO_CONTROL_AMMO_Y 140

#define WAIT_CAMBIO 600

#define NUM_PUNTOS_CONTROL 5

void moveUp(TEntity* prota);
void moveDown(TEntity* prota);
void moverIzquierda(TEntity* prota);
void moverDerecha(TEntity* prota);
u8 moverDerechaEnemigo(TEntity* enemigo);
u8 moverAbajoEnemigo(TEntity* enemigo);
u8 moveUpEnemigo(TEntity* enemigo);
u8 moveDownEnemigo(TEntity* enemigo);
u8 disparar(TEntity* prota);
u8 sobreSuelo(TEntity* prota);
u8* obtenerTilePtr(u8 x, u8 y,u8 nmapa);
u8 comprobarColision(TEntity* entity1, TEntity* entity2);
u8 colisionAmmo(TEntity* entity1, TAmmo* entity2);
u8 colisionVida(TEntity* entity1, TVida* entity2);
u8 colisionBala(TEntity* entity1, TBala* entity2);
u8 colisionAbajoDerecha(TEntity* prota);
u8 colisionAbajoIzquierda(TEntity* prota);
u8 colisionArribaDerecha(TEntity* prota);
u8 colisionArribaIzquierda(TEntity* prota);
void trayectoBala(TEntity* entity);

void colisionBalaMapa(TEntity* prota);
u8 colisionAbajoDerechaBala(TEntity* prota);
u8 colisionAbajoIzquierda(TEntity* prota);
u8 colisionArribaDerechaBala(TEntity* prota);
u8 colisionArribaIzquierdaBala(TEntity* prota);

//IA
i16 abs(i16 num);
i16 sqrt(i16 n);
u8 pow(u8 x, u8 n);
void moverPuntoControl(TEntity* enemigo, TEntity* prota, u8 IDDestino);
void decidirPuntoControl(TEntity* enemigo, TEntity* prota, u8 IDDestino);
void tomarDecision(TEntity* enemigo, TEntity* prota);
u8 enLaEspalda(TEntity* enemigo, TEntity* prota);
void esquivarEnemigo(TEntity* enemigo, TEntity* prota);
void realizarAccion(TEntity* enemigo, TEntity* prota);
void decidirPuntoControlPerseguir(TEntity* enemigo, TEntity* prota);
u8 decisionEsquivar2(TEntity* enemigo, TEntity* prota,i16 xE, i16 yE);

void moviendoMapa(TEntity* enemigo);
//u8 decisionEsquivar(TEntity* enemigo, TEntity* prota,i16 xE, i16 yE);
u8 direccionEnemigo(TEntity* enemigo, TEntity* prota);
void moverParaDisparar(TEntity* enemigo, TEntity* prota, u8 dir);

#endif