#include <cpctelera.h>

#include "sprites/prota.h"
#include "sprites/enemigo.h"
#include "sprites/ammo.h"
#include "sprites/vida.h"
#include "maps/mapa1.h"
#include "maps/mapa2.h"
#include "maps/mapa3.h"
#include "maps/mapa4.h"
#include "maps/mapa5.h"
#include "maps/mapa6.h"
#include "sprites/paleta3.h"
#include "sprites/disparo.h"
#include "entities/entities.h"


cpctm_createTransparentMaskTable(g_tablatrans, 0x0100, M0, 0);

const u8 g_score[12 * 18] = {
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,


};


u8* const g_animationDerecha[ANIM_FRAMES] = {
	g_prota_00, g_prota_01, g_prota_02,g_prota_03,
};

u8* const g_animationIzquierda[ANIM_FRAMES] = {
	g_prota_04, g_prota_05, g_prota_06,g_prota_07,
};


u8* const g_animationAbajo[ANIM_FRAMES] = {
	g_prota_08, g_prota_09, g_prota_10,g_prota_11,
};

u8* const g_animationArriba[ANIM_FRAMES] = {
	g_prota_12, g_prota_13, g_prota_14,g_prota_15,
};


u8* const g_animationEnemigoDerecha[ANIM_FRAMES] = {
	g_enemigo_00, g_enemigo_01, g_enemigo_02,g_enemigo_03,
};

u8* const g_animationEnemigoIzquierda[ANIM_FRAMES] = {
	g_enemigo_04, g_enemigo_05, g_enemigo_06,g_enemigo_07,
};


u8* const g_animationEnemigoArriba[ANIM_FRAMES] = {
	g_enemigo_08, g_enemigo_09, g_enemigo_10,g_enemigo_11,
};

u8* const g_animationEnemigoAbajo[ANIM_FRAMES] = {
	g_enemigo_12, g_enemigo_13, g_enemigo_14,g_enemigo_15,
};

TEntity prota;
TEntity enemigos[NUM_ENEMIGOS];
TAmmo ammo[NUM_MAPAS];
TVida vida[NUM_MAPAS];
u8* mapa;
u8 frame;
u8 cycles;
u8 wait_cycles; 
u8 wait_ammo;
u8 wait_vida;

u8 wait_danyo;
u8 time_danyo;
u8 ciclos_danyo;

//IA
u8 mHor;
u8 mVer;
u8 inicializadoGame=1;


void inicializarJuego(){

	u8 i;
	//prota
	prota.x=prota.px=prota.xIni=20;
	prota.y=prota.py=prota.yIni=70;
	prota.sprite=g_prota_00;
	prota.dir=derecha;
	prota.estadoAnterior=prota.state=parado;
	prota.vida=5;
	prota.yaParado=NO;
	prota.municion=20;
	prota.puntuacion=1;
	prota.nmapa=1;
	//bala del prota
	prota.bala.x=prota.x;
	prota.bala.y=prota.y;
	prota.bala.disparado=0;
	prota.bala.colisionado=0;
	prota.bala.dir=derecha;
	prota.danyado=NO;

	//nmapa=0;
	frame=0;
	cycles=0;
	wait_cycles=6;
	wait_ammo=60;
	wait_vida=200;

	wait_danyo=10;
	time_danyo=0;
	ciclos_danyo=0;

	mHor=0;
	mVer=0;
	//enemigos

	for(i=0; i<NUM_ENEMIGOS;i++){

	enemigos[i].dir=derecha;
	enemigos[i].estadoAnterior=enemigos[0].state=parado;
	enemigos[i].vida=5;
	enemigos[i].yaParado=NO;
	enemigos[i].municion=20;
	enemigos[i].danyado=NO;

	enemigos[i].bala.x=enemigos[i].x;
	enemigos[i].bala.y=enemigos[i].y;
	enemigos[i].bala.disparado=0;
	enemigos[i].bala.colisionado=0;
	enemigos[i].bala.dir=derecha;
	enemigos[i].PuntoDecidido=NO;
	enemigos[i].IDPuntoControl=10;
	enemigos[i].IDDecidido=10;
	enemigos[i].WaitCambioMapa=0;
	enemigos[i].masRango=i*4;

	enemigos[i].x=enemigos[i].px=enemigos[i].xIni=30;
	enemigos[i].y=enemigos[i].py=enemigos[i].yIni=50;
	}


	enemigos[0].sprite=g_enemigo_01;
	enemigos[0].nmapa=0;

	enemigos[1].sprite=g_enemigo_02;
	enemigos[1].nmapa=2;


	enemigos[2].sprite=g_enemigo_02;
	enemigos[2].nmapa=5;

	enemigos[3].sprite=g_enemigo_02;
	enemigos[3].nmapa=3;


	
	for(i=0;i<NUM_MAPAS;i++){
	//municion
		ammo[i].x=30;
		ammo[i].y=140;
		ammo[i].sprite=g_ammo;
		ammo[i].draw=SI;
		ammo[i].time_ammo=0;
	//vida
		vida[i].x=PUNTO_CONTROL_VIDA_X;
		vida[i].y=PUNTO_CONTROL_VIDA_Y;
		vida[i].sprite=g_vida;
		vida[i].draw=SI;
		vida[i].time_vida=0;

	}

}

void respawnEnemigo(TEntity* enemigo, u8 i){
	//enemigos

	enemigo->dir=derecha;
	enemigo->estadoAnterior=enemigos->state=parado;
	enemigo->vida=5;
	enemigo->yaParado=NO;
	enemigo->municion=20;
	enemigo->danyado=NO;

	enemigo->bala.x=enemigo->x;
	enemigo->bala.y=enemigo->y;
	enemigo->bala.disparado=0;
	enemigo->bala.colisionado=0;
	enemigo->bala.dir=derecha;
	enemigo->PuntoDecidido=NO;
	enemigo->IDPuntoControl=10;
	enemigo->IDDecidido=10;
	enemigo->WaitCambioMapa=0;


	enemigo->x=enemigos->px=enemigos->xIni=30;
	enemigo->y=enemigos->y=enemigos->yIni=50;

	switch(i){

		case 0:
			if(prota.nmapa!=0){
				enemigo->nmapa=0;
			}
			else{
				enemigo->nmapa=1;
			}
		break;

		case 1:
			if(prota.nmapa!=2){
				enemigo->nmapa=2;
			}
			else{
				enemigo->nmapa=5;
			}		
		break;

		case 2:
			if(prota.nmapa!=5){
				enemigo->nmapa=5;
			}
			else{
				enemigo->nmapa=4;
			}		
		break;

		case 3:
			if(prota.nmapa!=3){
				enemigo->nmapa=3;
			}
			else{
				enemigo->nmapa=0;
			}		
		break;

	}

	//bala del enemigo

}
/*

u8* obtenerTilePtr(u8 x, u8 y) {
   return mapa + (y-ORIGEN_MAPA_Y)/4*g_mapa1_W + x/2;
}

u8 sobreSuelo() {
   u8* tileSuelo = obtenerTilePtr(prota->x+2, prota->y + 27+1);
   if (*tileSuelo != 8 || *(tileSuelo+G_HERO_00_W/2-3) != 8)
      return 1;

   return 0;
}*/

//DIBUJAR

void dibujarMapa(){
	cpct_etm_drawTilemap2x4(g_mapa1_W, g_mapa1_H, ORIGEN_MAPA, mapa);
}



void dibujarEnemigos(u8 i){
	u8* pvmem;

	pvmem = cpct_getScreenPtr(CPCT_VMEM_START, enemigos[i].x, enemigos[i].y);


	if(enemigos[i].dir==derecha)
		cpct_drawSpriteMaskedAlignedTable(g_animationEnemigoDerecha[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(enemigos[i].dir==izquierda)
		cpct_drawSpriteMaskedAlignedTable(g_animationEnemigoIzquierda[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(enemigos[i].dir==arriba)
		cpct_drawSpriteMaskedAlignedTable(g_animationEnemigoArriba[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(enemigos[i].dir==abajo)
		cpct_drawSpriteMaskedAlignedTable(g_animationEnemigoAbajo[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
/*
	for(i=0;i<NUM_ENEMIGOS;i++){
		if(enemigos[i].nmapa==prota.nmapa){
		pvmem = cpct_getScreenPtr(CPCT_VMEM_START, enemigos[i].x, enemigos[i].y);
		if(enemigos[i].danyado==NO){
			//si no esta danyado se dibuja siempre
			cpct_drawSpriteMaskedAlignedTable(enemigos[i].sprite, pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
		}else{
			//si esta danyado se dibuja solo cierto tiempo para hacer un parpadeo
			if(++time_danyo==2 || time_danyo==4){
				cpct_drawSpriteMaskedAlignedTable(enemigos[i].sprite, pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
			}
			if(time_danyo==wait_danyo){
				time_danyo=0;
				ciclos_danyo++;
			}
			if(ciclos_danyo==6){
				enemigos[i].danyado=NO;
				ciclos_danyo=0;
			}
		}
		

		}

		
	}*/
	

}

void borrarEnemigos(u8 i){


	u8 w = 5 + (enemigos[i].px & 1);
	u8 h = 5 +  (enemigos[i].py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (enemigos[i].px /2, (enemigos[i].py-ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, mapa);



}

void redibujarEnemigos(){

	u8 i;

	for(i=0; i<NUM_ENEMIGOS;i++){
		if(enemigos[i].nmapa==prota.nmapa){



			borrarEnemigos(i);


			enemigos[i].px=enemigos[i].x;
			enemigos[i].py=enemigos[i].y;

			if(enemigos[i].danyado==NO){

				dibujarEnemigos(i);
			}
			else{
	//si esta danyado se dibuja solo cierto tiempo para hacer un parpadeo
				if(++time_danyo==2 || time_danyo==3 || time_danyo==5 || time_danyo==6 || time_danyo==8 || time_danyo==9){
					dibujarEnemigos(i);
				}
				if(time_danyo==wait_danyo){
					time_danyo=0;
					ciclos_danyo++;
				}
				if(ciclos_danyo==4){
					enemigos[i].danyado=NO;
					ciclos_danyo=0;
				}
			}
		}
	}



}


void dibujarProta(){

	u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, prota.x, prota.y);

	if(prota.dir==derecha)
		cpct_drawSpriteMaskedAlignedTable(g_animationDerecha[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(prota.dir==izquierda)
		cpct_drawSpriteMaskedAlignedTable(g_animationIzquierda[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(prota.dir==arriba)
		cpct_drawSpriteMaskedAlignedTable(g_animationArriba[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

	if(prota.dir==abajo)
		cpct_drawSpriteMaskedAlignedTable(g_animationAbajo[frame], pvmem, G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);

}

void dibujarSpriteParado(){

	u8* pvmem = cpct_getScreenPtr(CPCT_VMEM_START, prota.x, prota.y);

	if(prota.dir==derecha)
		cpct_drawSpriteMaskedAlignedTable(g_prota_00, pvmem , G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
	if(prota.dir==izquierda)
		cpct_drawSpriteMaskedAlignedTable(g_prota_04, pvmem , G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
	if(prota.dir==abajo)
		cpct_drawSpriteMaskedAlignedTable(g_prota_08, pvmem , G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
	if(prota.dir==arriba)
		cpct_drawSpriteMaskedAlignedTable(g_prota_12, pvmem , G_PROTA_00_W, G_PROTA_00_H, g_tablatrans);
}


void borrarProta(){

	u8 w = 5 + (prota.px & 1);
	u8 h = 5 +  (prota.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (prota.px /2, (prota.py-ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, mapa);

}


void redibujarProta(){
	if(prota.state==moviendo){ //si te estas moviendo dibuja la animacion de moverse llamando a dibujar prota
		prota.state=parado;
		prota.yaParado=NO;
		borrarProta();
		prota.px=prota.x;
		prota.py=prota.y;
		if(prota.danyado==SI){
				if(++time_danyo==2 || time_danyo==3 || time_danyo==5 || time_danyo==6 || time_danyo==8 || time_danyo==9){
				dibujarProta();
			}
			if(time_danyo==wait_danyo){
				time_danyo=0;
				ciclos_danyo++;
			}
			if(ciclos_danyo==4){
				prota.danyado=NO;
				ciclos_danyo=0;
			}
		}
		else{
			dibujarProta();
		}
	}else if((prota.state==parado && prota.yaParado==NO) || (prota.state==parado && prota.danyado==SI)){ //si estas parado, dibuja SOLO LA PRIMERA VEZ QUE TE QUEDAS PARADO el personaje con el sprite parado.
		if(prota.danyado==NO){
			//borrarProta();
			prota.px=prota.x;
			prota.py=prota.y;
			prota.yaParado=SI;

			dibujarSpriteParado();
		}
		else{
			borrarProta();
			prota.px=prota.x;
			prota.py=prota.y;
			if(prota.danyado==SI){
				if(++time_danyo==2 || time_danyo==3 || time_danyo==5 || time_danyo==6 || time_danyo==8 || time_danyo==9){
					dibujarSpriteParado();
				}
				if(time_danyo==wait_danyo){
					time_danyo=0;
					ciclos_danyo++;
				}
				if(ciclos_danyo==4){
					prota.danyado=NO;
					ciclos_danyo=0;
					dibujarSpriteParado();
				}
			}
			else{
				dibujarSpriteParado();
			}
		}

	}
}


void borrarBala(){
	//u8 w = 1;
	//u8 h = 4;
	u8 w = 1 + (prota.bala.px & 1);
	u8 h = 1 +  (prota.bala.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (prota.bala.px /2, (prota.bala.py - ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, mapa);
}

void dibujarBala(){

	if(prota.bala.nmapa==prota.nmapa)
	cpct_drawSpriteMaskedAlignedTable(g_disparo, cpct_getScreenPtr(CPCT_VMEM_START,  prota.bala.x,prota.bala.y), 1, 4, g_tablatrans);
	//bala.disparado=NO;

}
void redibujarBala(){

	borrarBala();
	prota.bala.px=prota.bala.x;
	prota.bala.py=prota.bala.y;
	dibujarBala();

}

void borrarBalaEnemigos(u8 i){
	//u8 w = 1;
	//u8 h = 4;
	u8 w = 1 + (enemigos[i].bala.px & 1);
	u8 h = 1 +  (enemigos[i].bala.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4 (enemigos[i].bala.px /2, (enemigos[i].bala.py - ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, mapa);
}

void dibujarBalaEnemigos(u8 i){
	if(enemigos[i].bala.nmapa==prota.nmapa)
	cpct_drawSpriteMaskedAlignedTable(g_disparo, cpct_getScreenPtr(CPCT_VMEM_START,  enemigos[i].bala.x,enemigos[i].bala.y), 1, 4, g_tablatrans);
	//bala.disparado=NO;

}

void redibujarBalaEnemigos(u8 i){

	borrarBalaEnemigos(i);
	enemigos[i].bala.px=enemigos[i].bala.x;
	enemigos[i].bala.py=enemigos[i].bala.y;
	dibujarBalaEnemigos(i);

}

// FIN DIBUJAR



void dibujarStringVida(){


	cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  67, 12), 2, 0, 48+(prota.vida));

}

void dibujarAmmo(TAmmo* ammo){

	if(ammo->draw==SI)
		cpct_drawSprite(ammo->sprite, cpct_getScreenPtr(CPCT_VMEM_START,  ammo->x,ammo->y), 3,8);
	

}

void borrarAmmo(TAmmo* ammo){

	u8 w = 3;
	u8 h = 8;
	//u8 w = 4 + (bala.balapx & 1);
	//u8 h = 7 +  (bala.balapy & 3 ? 1 : 0);

	cpct_etm_drawTileBox2x4 (ammo->x /2, (ammo->y- ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, g_mapa1);
}

void dibujarVida(TVida* vida){

	if(vida->draw==SI)
		cpct_drawSprite(vida->sprite, cpct_getScreenPtr(CPCT_VMEM_START,  vida->x,vida->y), 3,8);
	

}

void borrarVida(TVida* vida){

	u8 w = 3;
	u8 h = 8;
	//u8 w = 4 + (bala.balapx & 1);
	//u8 h = 7 +  (bala.balapy & 3 ? 1 : 0);

	
	cpct_etm_drawTileBox2x4 (vida->x /2, (vida->y- ORIGEN_MAPA_Y)/4, w, h, g_mapa1_W,ORIGEN_MAPA, g_mapa1);
	
	

}

void dibujarStringAmmo(){

	if(prota.municion>=10){
		cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  24, 12), 2, 0, 48+prota.municion/10);
	}
	else{
		cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  24, 12), 2, 0, 48);

	}
	cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  28, 12), 2, 0, 48+(prota.municion%10));

}

void dibujarScore(){

	cpct_drawSprite(g_score, cpct_getScreenPtr(CPCT_VMEM_START, 116,6), 12,18);
	if(prota.puntuacion>=10){
		cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  118, 11), 15, 0, 47+prota.puntuacion/10);
	}
	else{
		cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  118, 11), 15, 0, 48);

	}
	cpct_drawCharM0 (cpct_getScreenPtr(CPCT_VMEM_START,  122, 11), 15, 0, 47+(prota.puntuacion%10));
}


void inicio(u8 inicioJuego){
  //  dibujarRotulo();
	if(inicioJuego){
		inicializarJuego();
		mapa = g_mapa2;
		

	}
	
	cpct_etm_setTileset2x4(p_tileset);
	dibujarMapa();

	dibujarStringAmmo();
	dibujarStringVida();
	dibujarScore();
	dibujarProta();


	inicializadoGame=1;
}

void retrocederMapa(){

	if(prota.nmapa ==1 || prota.nmapa==2 || prota.nmapa==4|| prota.nmapa==5){
		if(prota.nmapa==1){
			mapa=g_mapa1;
		}
		if(prota.nmapa==2){
			mapa=g_mapa2;
		}
		if(prota.nmapa==4){
			mapa=g_mapa4;
		}
		if(prota.nmapa==5){
			mapa=g_mapa5;
		}
		prota.nmapa--;
		prota.x=ANCHO_PANTALLA - G_PROTA_00_W;
		prota.state=moviendo;
		dibujarMapa();
		dibujarStringAmmo();
		dibujarStringVida();
		dibujarScore();

	}

}

void avanzarMapa(){

	if(prota.nmapa ==0 || prota.nmapa==1|| prota.nmapa==3|| prota.nmapa==4){
		if(prota.nmapa==0){
			mapa=g_mapa2;
		}
		if(prota.nmapa==1){
			mapa=g_mapa3;
		}
		if(prota.nmapa==3){
			mapa=g_mapa5;
		}
		if(prota.nmapa==4){
			mapa=g_mapa6;
		}
		prota.nmapa++;	
		prota.x=0;
		prota.state=moviendo;
		dibujarMapa();

		dibujarStringAmmo();
		dibujarStringVida();
		dibujarScore();

	}

}

void bajarMapa(){

	if(prota.nmapa ==0 || prota.nmapa==1|| prota.nmapa==2){
		if(prota.nmapa==0){
			mapa=g_mapa4;
		}
		else if(prota.nmapa==1){
			mapa=g_mapa5;
		}
		else if(prota.nmapa==2){
			mapa=g_mapa6;
		}	
		prota.nmapa=prota.nmapa+3;
		prota.y=34;
		prota.state=moviendo;
		dibujarMapa();

		dibujarStringAmmo();
		dibujarStringVida();
		dibujarScore();

	}

}
void subirMapa(){

	if(prota.nmapa ==3 || prota.nmapa==4|| prota.nmapa==5){
		if(prota.nmapa==3){
			mapa=g_mapa1;
		}
		else if(prota.nmapa==4){
			mapa=g_mapa2;
		}
		else if(prota.nmapa==5){
			mapa=g_mapa3;
		}		
		prota.nmapa=prota.nmapa-3;	
		prota.y=ALTO_PANTALLA - G_PROTA_00_H-5;
		prota.state=moviendo;
		dibujarMapa();

		dibujarStringAmmo();
		dibujarStringVida();
		dibujarScore();

	}

}

void restarVida(){
	if(prota.danyado==NO){
		prota.danyado=SI;
		prota.vida--;
		dibujarStringVida();
	}
}

void comprobarTeclado(){
	//TEntity myEntity=
	

	if(cpct_isAnyKeyPressed()){
		if(cpct_isKeyPressed(Key_CursorRight)){
			moverDerecha(&prota);
		}
		else if(cpct_isKeyPressed(Key_CursorLeft)){
			moverIzquierda(&prota);
		}
		else if(cpct_isKeyPressed(Key_CursorUp)){
			moveUp(&prota);
		}
		else if(cpct_isKeyPressed(Key_CursorDown)){
			moveDown(&prota);
		}
		if(cpct_isKeyPressed(Key_A)){
			prota.vida=0;
		}
		if(cpct_isKeyPressed(Key_S)){
			enemigos[0].municion=0;	
		}
		if(cpct_isKeyPressed(Key_Space)){
			if(disparar(&prota)){
				borrarBala();
				dibujarStringAmmo();
			}
			//dibujarStringVida();
			//restarVida();

		}	

	}
}

/*
void moverIA(){
	//funcion inicial para ver si se movian los personajes, igual de aqui se puede rescatar algo para cuando el enemigo 
	//tenga que perseguir al enemigo pero esto era una prueba inicial no hacerle mucho caso
	u8 i;
	for(i=0;i<2;i++){
		if(mHor<maxHor){
			//si no has movido ya el maximo horizontal compruebas hacia donde tienes que ir y te mueves en esa direccion
			if(enemigos[i].x-prota.x<0){
				enemigos[i].dir=derecha;
				moverIADerecha(&enemigos[i], prota.nmapa);
				mHor++;
		}else{
			enemigos[i].dir=izquierda;
			moverIAIzquierda(&enemigos[i], prota.nmapa);
			mHor++;
			}
		}else if(mVer<maxVer){
			//cuando ya has hecho los maximos movimientos horizontales llegas aqui, hasta que hagas los maximos verticales y se reinicien los movimeintos
			if(enemigos[i].y-prota.y<0){
				enemigos[i].dir=abajo;
				moverIADown(&enemigos[i], prota.nmapa);
				mVer++;
		}else{
			enemigos[i].dir=arriba;
			moverIAUp(&enemigos[i], prota.nmapa);
			mVer++;
			}


		}else{
			mHor=0;
			mVer=0;
		}

	}
}
*/



u8 juego() {
	u8 i;
	u8 numEnemigosMapa=0;

	

	if (++cycles == wait_cycles) {
         cycles = 0;                   // Restart frame counter
         if (++frame == ANIM_FRAMES) {  // Next animation frame
         	frame = 0;
         }

         for(i=0; i<NUM_MAPAS;i++){
         	if(vida[i].draw==NO){
         		if(++vida[i].time_vida == wait_vida){
         			vida[i].time_vida=0;
         			vida[i].draw=SI;
         		}
         	}
         	if(ammo[i].draw==NO){
         		if(++ammo[i].time_ammo == wait_vida){
         			ammo[i].time_ammo=0;
         			ammo[i].draw=SI;
         		}
         	}
         }


         if(prota.bala.disparado==SI){
			//aqui haciamos la logica de si la bala ha chocado con la pared, ahora la hacemos en la funcion para poder
         	//reutilizar la misma logica para las balas de los enemigos
         	trayectoBala(&prota);
         	colisionBalaMapa(&prota);
         }
     

     for(i=0;i<NUM_ENEMIGOS;i++){

     	if(enemigos[i].bala.disparado==SI){
     		trayectoBala(&enemigos[i]);
     		colisionBalaMapa(&enemigos[i]);
     		//cpct_drawStringM0("DISPARANDO ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 80),  2, 5);

     	}

     	if(colisionBala(&enemigos[i],&prota.bala)==1){
     		//cpct_drawStringM0("Bala choca ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 96),  2, 5);
     		//esto tiene que estar aqui delante para que la primera vez que entre danyado es no y le resta 1 vida
     		if(enemigos[i].danyado==NO){
     			enemigos[i].vida--;
     			enemigos[i].danyado=SI;
     			prota.bala.colisionado=SI;
     			prota.bala.disparado=NO;
     		}
     		//el resto de la logica de restar vida al enemigo esta en dibujarEnemigos();
     		
     		if(enemigos[i].vida<=0){
     			//se suma un punto al prota
     			if(prota.puntuacion<99)
     			prota.puntuacion++;
     			dibujarScore();
     			//se vuelve a resetear el enemigo
     			borrarEnemigos(i);
     			respawnEnemigo(&enemigos[i], i);

     		}
     	}

     	if(colisionBala(&prota,&enemigos[i].bala)==1){
     		//cpct_drawStringM0("Bala choca ", cpct_getScreenPtr(CPCT_VMEM_START, 10, 96),  2, 5);
     		//esto tiene que estar aqui delante para que la primera vez que entre danyado es no y le resta 1 vida
     		if(prota.danyado==NO){
     			restarVida();
     			enemigos[i].bala.colisionado=SI;
     			enemigos[i].bala.disparado=NO;
     		}
     		//el resto de la logica de restar vida al enemigo esta en dibujarEnemigos();
     		
     	}

     	if(colisionVida(&enemigos[i], &vida[enemigos[i].nmapa])==1){

     		if(vida[enemigos[i].nmapa].draw==SI){
     			enemigos[i].vida++;
     			vida[enemigos[i].nmapa].draw=NO;
     			enemigos[i].IDPuntoControl=10;
     			borrarVida(&vida[enemigos[i].nmapa]);
     		}
     	}

     	if(colisionAmmo(&enemigos[i], &ammo[enemigos[i].nmapa])==1){

     		if(ammo[enemigos[i].nmapa].draw==SI){
     			enemigos[i].municion=20;
     			ammo[enemigos[i].nmapa].draw=NO;
     			enemigos[i].IDPuntoControl=10;
     			borrarAmmo(&ammo[enemigos[i].nmapa]);
     		}
     	}

     	if(enemigos[i].nmapa==prota.nmapa){
     		numEnemigosMapa++;
     	}



     }

     for(i=0; i<NUM_ENEMIGOS;i++){

     	if(numEnemigosMapa<2){

     		tomarDecision(&enemigos[i], &prota);

     		realizarAccion(&enemigos[i], &prota);

     	}
     	else if(enemigos[i].nmapa==prota.nmapa){

     		tomarDecision(&enemigos[i], &prota);

     		realizarAccion(&enemigos[i], &prota);
     	}

     }




     if(colisionAmmo(&prota, &ammo[prota.nmapa])==1){

     	if(ammo[prota.nmapa].draw==SI){
     		prota.municion=20;
     		dibujarStringAmmo();
     		ammo[prota.nmapa].draw=NO;
     		borrarAmmo(&ammo[prota.nmapa]);
     	}
     }


     if(colisionVida(&prota, &vida[prota.nmapa])==1){

     	if(vida[prota.nmapa].draw==SI){
     		prota.vida++;
     		dibujarStringVida();
     		vida[prota.nmapa].draw=NO;
     		borrarVida(&vida[prota.nmapa]);
     	}
     }


 	//Aqui termina el wait cycles
     comprobarTeclado();

     cpct_waitVSYNC();
     //cpct_akp_musicPlay();


     //moverIA();
     dibujarAmmo(&ammo[prota.nmapa]);
     dibujarVida(&vida[prota.nmapa]);
     redibujarEnemigos();
     redibujarProta();




}


     if(prota.bala.disparado==SI){
     	redibujarBala();
     }
     if(prota.bala.colisionado==SI){
     	borrarBala();
     	prota.bala.colisionado=NO;
     }


for(i=0; i<NUM_ENEMIGOS; i++){

     if(enemigos[i].bala.disparado==SI){
     	redibujarBalaEnemigos(i);
     }
     if(enemigos[i].bala.colisionado==SI){
     	borrarBalaEnemigos(i);
     	enemigos[i].bala.colisionado=NO;
     }
}




     if (!inicializadoGame){
     	prota.vida=5;
     }

     if(prota.vida<1){
     	inicializadoGame=0;
     	return prota.puntuacion;
     }

 

     return 0;

 }

