#ifndef _GAME_H_
#define _GAME_H_

#include <types.h>

#define ANCHO 80
#define ALTO 200

#define ORIGEN_MAPA_Y 0
#define ORIGEN_MAPA cpctm_screenPtr(CPCT_VMEM_START, 0, ORIGEN_MAPA_Y)
#define ANCHO_PANTALLA 80
#define LIMITE_DERECHO ANCHO_PANTALLA - G_PROTA_00_W
#define ALTO_PANTALLA 200

#define SI 1
#define NO 0


#define ANCHO_PROTA G_PROTA_00_W
#define ALTO_PROTA G_PROTA_00_H

#define ANCHO_BALA G_DISPARO_W
#define ALTO_BALA G_DISPARO_H


#define NUM_MAPAS 6
#define ANIM_FRAMES  4
#define NUM_ENEMIGOS 4

#define maxHor 10
#define maxVer 4



typedef enum{
	izquierda,
	derecha,
	arriba,
	abajo
} TDir;

typedef struct{

u8 x, y;
u8 px, py;
u8 disparado;
u8 colisionado;
TDir dir;
u8 nmapa;
} TBala;

typedef struct{

u8 x, y;
u8* sprite;
u8 draw;
u8 time_ammo;
} TAmmo;

typedef struct{

u8 x, y;
u8* sprite;
u8 draw;
u8 time_vida;
} TVida;

typedef struct{

u8 x, y;
} TArrDer;
typedef struct{

u8 x, y;
} TArrIzq;

typedef struct{

u8 x, y;
} TAbDer;

typedef struct{

u8 x, y;
} TAbIzq;


typedef enum {
   parado, 
   moviendo,
   perseguir,
   pocaMunicion,
   posicionDisparar,
   pocaVida,
   disparando,
   esquivar
} TEstadoEntity;

typedef struct BoundingBox
{
	TArrDer arrDer;
	TArrIzq arrIzq;
	TAbDer	abDer;
	TAbIzq	abIzq;
} TBoundingBox;


typedef struct Entity
{
	u8 x,y;
	u8 px,py;
	u8 xIni, yIni;
	u8* sprite;
	TDir dir;
	TEstadoEntity state;
	TEstadoEntity estadoAnterior;
	u8 vida;
	u8 yaParado;
	u8 municion;
	TBala bala;
	TBoundingBox bound;
	u8 danyado;
	u8 puntuacion;
	u8 nmapa;
	u8 PuntoDecidido;
	u8 IDPuntoControl;
	u8 IDDecidido;
	u16 WaitCambioMapa;
	u8 masRango;
} TEntity;




void inicio(u8 inicioJuego);
void respawnEnemigo(TEntity* enemigo, u8 i);
//dibujar
void dibujarMapa();
void dibujarSpriteParado();
void dibujarRotulo();
void dibujarProta();
void borrarProta();
void redibujarProta();
void redibujarBala();
void borrarBala();
void dibujarBala();
void redibujarBalaEnemigos(u8 i);
void borrarBalaEnemigos(u8 i);
void dibujarBalaEnemigos(u8 i);
void dibujarEnemigos(u8 i);
void borrarEnemigos(u8 i);
void redibujarEnemigos();
void dibujarScore();

void dibujarAmmo(TAmmo* ammo);
void borrarAmmo(TAmmo* ammo);
void dibujarVida(TVida* vida);
void borrarVida(TVida* vida);
//cambiar mapa
void avanzarMapa();
void retrocederMapa();
void subirMapa();
void bajarMapa();

//juego
void comprobarTeclado();
u8 juego();


#endif